unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,mmsystem;

type
  TFrmEditAddIrCodeAction = class(TForm)
    RadStartProgram: TRadioButton;
    RadSendKey: TRadioButton;
    EdtKey: TEdit;
    EdtKeyProgram: TEdit;
    butSelectKeyProgram: TButton;
    RadSendAltKey: TRadioButton;
    EdtAltKey: TEdit;
    edtAltKeyProgram: TEdit;
    butSelectAltKeyProgram: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    edtStartProgram: TEdit;
    ButSelectStartProgram: TButton;
    RadQuitProgram: TRadioButton;
    edtQuitProgram: TEdit;
    ButSelectQuitProgram: TButton;
    Label6: TLabel;
    GroupBox2: TGroupBox;
    edtIRCode: TEdit;
    ButIRGetCode: TButton;
    Label7: TLabel;
    ButIRCancel: TButton;
    butAdd: TButton;
    ButCancel: TButton;
    ButEdit: TButton;
    Timer: TTimer;
    EdtKeychar: TEdit;
    EdtAltKeyChar: TEdit;
    OpenDialog: TOpenDialog;
    Timer2: TTimer;
    Timer1: TTimer;
    Timer3: TTimer;
    procedure ButIRGetCodeClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure ButIRCancelClick(Sender: TObject);
    procedure RadStartProgramClick(Sender: TObject);
    procedure RadQuitProgramClick(Sender: TObject);
    procedure RadSendKeyClick(Sender: TObject);
    procedure RadSendAltKeyClick(Sender: TObject);
    procedure ButSelectStartProgramClick(Sender: TObject);
    procedure ButSelectQuitProgramClick(Sender: TObject);
    procedure butSelectKeyProgramClick(Sender: TObject);
    procedure EdtKeyKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EdtKeycharKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EdtAltKeyKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EdtAltKeyCharKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer2Timer(Sender: TObject);
    procedure butSelectAltKeyProgramClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Passed : longint;
    procedure TimerGetClassName(Timer : TTimer;EditControl : TEdit);
  end;
var
  FrmEditAddIrCodeAction: TFrmEditAddIrCodeAction;
  oldwinhandle : hwnd = 0;
implementation

uses unit1;
{$R *.dfm}

procedure TFrmEditAddIrCodeAction.ButIRGetCodeClick(Sender: TObject);
begin
  Timer.enabled := true;
  butircancel.Enabled := true;
  Butirgetcode.Enabled := false;
end;

procedure TFrmEditAddIrCodeAction.TimerTimer(Sender: TObject);
var
  key:DWORD;
begin
  if not started then exit;
  key := FrmIrMonitor.ReadRemoteData;
  if key<>$FF then begin
    edtircode.Text := inttostr( key);
    Timer.Enabled := false;
    Butircancel.Enabled := false;
    butirgetcode.Enabled := true;
  end;
end;


procedure TFrmEditAddIrCodeAction.ButIRCancelClick(Sender: TObject);
begin
 Timer.Enabled := false;
 Butircancel.Enabled := false;
 butirgetcode.Enabled := true;
end;

procedure TFrmEditAddIrCodeAction.RadStartProgramClick(Sender: TObject);
begin
 if radstartprogram.Checked then
 begin
  edtquitprogram.Text := '';
  edtkey.Text := '';
  edtkeyprogram.Text := '';
  edtkeychar.Text := '';
  edtaltkey.Text := '';
  edtaltkeychar.Text := '';
  edtaltkeyprogram.Text := '';
  butselectquitprogram.Enabled := false;
  butselectkeyprogram.Enabled := false;
  butselectaltkeyprogram.Enabled := false;
  butselectstartprogram.Enabled := true;
 end;
end;

procedure TFrmEditAddIrCodeAction.RadQuitProgramClick(Sender: TObject);
begin
 if radQuitprogram.Checked then
 begin
  edtstartprogram.Text := '';
  edtkey.Text := '';
  edtkeychar.Text := '';
  edtkeyprogram.Text := '';
  edtaltkey.Text := '';
  edtaltkeychar.Text := '';
  edtaltkeyprogram.Text := '';
  butselectstartprogram.Enabled := false;
  butselectaltkeyprogram.Enabled := false;
  butselectkeyprogram.Enabled := false;
  butselectquitprogram.Enabled := true;
 end;
end;

procedure TFrmEditAddIrCodeAction.RadSendKeyClick(Sender: TObject);
begin
 if radSendKey.Checked then
 begin
  edtstartprogram.Text := '';
  edtquitprogram.Text := '';
  edtaltkey.Text := '';
  edtaltkeychar.Text := '';
  edtaltkeyprogram.Text := '';
  butselectstartprogram.Enabled := false;
  butselectquitprogram.Enabled := false;
  butselectaltkeyprogram.Enabled := false;
  butselectkeyprogram.Enabled := true;
 end;
end;

procedure TFrmEditAddIrCodeAction.RadSendAltKeyClick(Sender: TObject);
begin
 if radSendAltKey.Checked then
 begin
  edtstartprogram.Text := '';
  edtquitprogram.Text := '';
  edtkey.Text := '';
  edtkeychar.Text := '';
  edtkeyprogram.Text := '';
  butselectquitprogram.Enabled := false;
  butselectstartprogram.Enabled := false;
  butselectkeyprogram.Enabled := false;
  butselectaltkeyprogram.Enabled := true;
 end;
end;

procedure TFrmEditAddIrCodeAction.ButSelectStartProgramClick(
  Sender: TObject);
begin
 edtquitprogram.Text := '';
 edtkey.Text := '';
 edtkeyprogram.Text := '';
 edtkeychar.Text := '';
 edtaltkey.Text := '';
 edtaltkeychar.Text := '';
 edtaltkeyprogram.Text := '';
 if opendialog.execute then edtstartprogram.Text := opendialog.FileName;
end;

procedure TFrmEditAddIrCodeAction.ButSelectQuitProgramClick(
  Sender: TObject);
begin
 edtstartprogram.Text := '';
 edtkey.Text := '';
 edtkeychar.Text := '';
 edtkeyprogram.Text := '';
 edtaltkey.Text := '';
 edtaltkeychar.Text := '';
 edtaltkeyprogram.Text := '';
 Passed := 0;
 oldwinhandle := 0;
 Timer3.enabled := true;
end;

procedure TFrmEditAddIrCodeAction.butSelectKeyProgramClick(
  Sender: TObject);
begin
  edtstartprogram.Text := '';
  edtquitprogram.Text := '';
  edtaltkey.Text := '';
  edtaltkeychar.Text := '';
  edtaltkeyprogram.Text := '';
  Passed := 0;
  oldwinhandle := 0;
  Timer2.enabled := true;
end;

procedure TFrmEditAddIrCodeAction.EdtKeyKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
 if radsendkey.Checked then
 begin
  edtKey.Text :=  inttostr(integer(key));
  edtkeychar.text := chr(Key);
 end;
 key := 0;
end;

procedure TFrmEditAddIrCodeAction.EdtKeycharKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
 if radsendkey.Checked then
 begin
  edtKey.Text :=  inttostr(integer(key));
  edtkeychar.text := chr(Key);
 end;
 key := 0;
end;

procedure TFrmEditAddIrCodeAction.EdtAltKeyKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
 if radsendaltkey.Checked then
 begin
  edtAltKey.Text := inttostr(integer(key));
  edtAltkeychar.text := chr(Key);
 end;
 key := 0;
end;

procedure TFrmEditAddIrCodeAction.EdtAltKeyCharKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
 if radsendaltkey.Checked then
 begin
  edtAltKey.Text := inttostr(integer(key));
  edtAltkeychar.text := chr(Key);
 end;
 key := 0;
end;

procedure TFrmEditAddIrCodeAction.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 if modalresult <> Mrcancel then
 begin
  if edtircode.Text = '' then
  begin
   application.MessageBox('Please Select an infra red code using the button "Get Code"'+chr(13)+'And By pressing a button on the remote!','No Infrared Code Selected!',MB_OK+MB_ICONEXCLAMATION);
   action := caNone;
  end;
 end;
end;

procedure FrameWindow(Wnd: HWnd);
var
  Rect: TRect;
  DC: hDC;
  OldPen, Pen: hPen;
  OldBrush, Brush: hBrush;
  X2, Y2: Integer;
begin
  { Get the target window's rect and DC }
  GetWindowRect(Wnd, Rect);
  DC := GetWindowDC(Wnd);
  { Set ROP appropriately for highlighting }
  SetROP2(DC, R2_NOT);
  { Select brush and pen }
  Pen := CreatePen(PS_InsideFrame, 2, clred);
  OldPen := SelectObject(DC, Pen);
  Brush := GetStockObject(Null_Brush);
  OldBrush := SelectObject(DC, Brush);
  { Set dimensions of highlight }
  X2 := Rect.Right - Rect.Left;
  Y2 := Rect.Bottom - Rect.Top;
  { Draw highlight box }
  Rectangle(DC, 0, 0, X2, Y2);
  { Clean up }
  SelectObject(DC, OldBrush);
  SelectObject(DC, OldPen);
  ReleaseDC(Wnd, DC);
  { Do NOT delete the brush, because it was a stock object }
  DeleteObject(Pen);
end;


procedure TFrmEditAddIrCodeAction.Timer2Timer(Sender: TObject);
begin
 TimerGetClassName(Timer2,EdtKeyProgram);
end;

procedure TFrmEditAddIrCodeAction.butSelectAltKeyProgramClick(
  Sender: TObject);
begin
  edtstartprogram.Text := '';
  edtquitprogram.Text := '';
  edtkey.Text := '';
  edtkeychar.Text := '';
  edtkeyprogram.Text := '';
  Passed := 0;
  oldwinhandle := 0;
  Timer1.enabled := true;
end;

procedure TFrmEditAddIrCodeAction.Timer1Timer(Sender: TObject);
begin
  TimerGetClassName(Timer1,EdtAltKeyProgram);
end;

Procedure TFrmEditAddIrCodeAction.TimerGetClassName(Timer : TTimer;EditControl : TEdit);
var
 P: Tpoint;
 winhandle : HWND;
 Classname : array[0..254] of char;
begin
 passed := passed + 30;
 getcursorPos(P);
 winhandle := windowfrompoint(P);
 if winhandle > 0 then
 begin
  if winhandle <> oldwinhandle then
  begin
   if getClassname(winhandle,classname,254) > 0 then
   begin
    EditControl.Text := Classname;
   end;
  end;

  if passed > 2000 then
  begin
   Timer.Enabled := false;
   sndplaysound(pchar(extractfilepath(application.exename)+'blip.wav'),SND_ASYNC);
   butselectstartprogram.Enabled := true;
   butselectQuitprogram.Enabled := true;
   butselectkeyprogram.Enabled := true;
   butselectAltkeyprogram.Enabled := true;
  end;
 end;
end;

procedure TFrmEditAddIrCodeAction.Timer3Timer(Sender: TObject);
begin
 TimerGetClassName(Timer3,EdtQuitProgram);
end;

end.
